/*============================================================================
  File:     RestoreSalesDB withDiffs.sql

  Summary:  Creates a copy of a modified version of the SalesDB so that 
			differences can be detected using TableDiff.exe.
  
  Date:     June 2007

  SQL Server Version: 9.00.3054.00 (SP2)
------------------------------------------------------------------------------
  Copyright (C) 2007 Kimberly L. Tripp, SQLskills.com
  All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  This script is intended only as a supplement to demos and lectures
  given by Kimberly L. Tripp.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

SET NOCOUNT ON
go

USE master
go

IF DATABASEPROPERTYEX('SalesDB_Diffs', 'Collation') IS NOT NULL
	ALTER DATABASE SalesDB_Diffs
		SET RESTRICTED_USER 
		WITH ROLLBACK IMMEDIATE
go

RESTORE DATABASE [SalesDB_Diffs] 
FROM DISK = N'C:\AlwaysOn Labs\Data Recovery Lab\SalesDBBackupForDiffs.BAK' 
WITH FILE = 1,  
	MOVE N'SalesDBData' TO N'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\DATA\SalesDB_Diffs.mdf',  
	MOVE N'SalesDBLog' TO N'C:\Program Files\Microsoft SQL Server\MSSQL.1\MSSQL\DATA\SalesDB_Diffs_0.ldf',  
NOUNLOAD, REPLACE, STATS = 10
go

