/*============================================================================
  File:     VerifyTableDifferences.sql

  Summary:  This script verifies the differences between the original SalesDB
			and the modified SalesDB restored as SalesDB_Diffs.
  
  Date:     June 2007

  SQL Server Version: 9.00.3054.00 (SP2)
------------------------------------------------------------------------------
  Copyright (C) 2007 Kimberly L. Tripp, SQLskills.com
  All rights reserved.

  For more scripts and sample code, check out 
    http://www.SQLskills.com

  This script is intended only as a supplement to demos and lectures
  given by Kimberly L. Tripp.  
  
  THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
  ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
  TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
  PARTICULAR PURPOSE.
============================================================================*/

-- If the commands were database commands, you could use the undocumented sp_msforeachtable command
-- The following line can help you to quickly find row count differences - but this doesn't account for
-- rows that have been deleted and new rows have been added.
-- sp_MSforeachtable @command1="select count(*) AS 'SalesDB_Diffs.?' from ?; select count(*) AS 'SalesDB.?' from SalesDB.?"  


------------------------------------------------------------------------------
-- Create a temp table to store the commands
------------------------------------------------------------------------------

USE SalesDB
go
CREATE TABLE ExecuteDifferences
(
	DiffID		int				identity,
	DiffExec	nvarchar(4000)
)
go

------------------------------------------------------------------------------
-- Create SQLCMD variables to help simplify the command build
------------------------------------------------------------------------------
:SETVAR SourceServer (local)\SQLDev01
:SETVAR SourceDatabase SalesDB_Diffs

:SETVAR DestinationServer (local)\SQLDev01
:SETVAR DestinationDatabase SalesDB

DECLARE @CurrentName sysname, @ExecStr nvarchar(4000)
SELECT @CurrentName = (SELECT min(name) FROM sys.tables WHERE name NOT IN ('sysdiagrams', 'ExecuteDifferences'))

WHILE @CurrentName <= (SELECT max(name) FROM sys.tables WHERE name NOT IN ('sysdiagrams', 'ExecuteDifferences')) 
BEGIN
	SELECT @ExecStr = 'INSERT ExecuteDifferences (DiffExec) VALUES (''!!"c:\program files\microsoft sql server\90\com\tablediff.exe" -sourceserver $(SourceServer) -sourcedatabase $(SourceDatabase) -sourcetable ' + @CurrentName + ' -destinationserver $(DestinationServer) -destinationdatabase $(DestinationDatabase) -destinationtable ' + @CurrentName + ' -c -dt ' + @CurrentName + '_Diffs -f c:\SQLskills\' + @CurrentName + '_Diffs.sql'')'
	--SELECT @ExecStr
	EXEC (@ExecStr)
	SELECT @CurrentName = (SELECT min(name) FROM sys.tables WHERE name NOT IN ('sysdiagrams', 'ExecuteDifferences') AND name > @CurrentName)
END
go

SELECT * FROM ExecuteDifferences
go